﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=7.8
@EndOfDesignText@
'Custom View class 
#Event: ExampleEvent (Value As Int)
#DesignerProperty: Key: TextOnOff, DisplayName: Text On/Off, FieldType: Boolean, DefaultValue: True, Description: Text visible or not.
#DesignerProperty: Key: TextBGOnOff, DisplayName: Text Background On/Off, FieldType: Boolean, DefaultValue: True, Description: Text BG visible or not.
#DesignerProperty: Key: MiddleOnOff, DisplayName: Middle On/Off, FieldType: Boolean, DefaultValue: True, Description: Middle Circle visible or not.
#DesignerProperty: Key: MinutesOnOff, DisplayName: Minutes On/Off, FieldType: Boolean, DefaultValue: True, Description: Minutes visible or not.
#DesignerProperty: Key: SecondOnOff, DisplayName: Seconds On/Off, FieldType: Boolean, DefaultValue: True, Description: Seconds visible or not.

#DesignerProperty: Key: TextOffset, DisplayName: Text Offset, FieldType: Float, DefaultValue: 75, MinRange: 25, MaxRange: 100, Description: Range between 25 and 100
#DesignerProperty: Key: FontSize, DisplayName: Font Size, FieldType: Float, DefaultValue: 7, MinRange: 1, MaxRange: 50, Description: Range between 1 and 50

#DesignerProperty: Key: WatchHandSize, DisplayName: Watch Hand Size, FieldType: Float, DefaultValue: 90, MinRange: 10, MaxRange: 100, Description: Range between 10 and 100
#DesignerProperty: Key: WatchHandMinSize, DisplayName: Watch Hand Min. Size, FieldType: Float, DefaultValue: 90, MinRange: 10, MaxRange: 100, Description: Range between 10 and 100
#DesignerProperty: Key: WatchHandSecSize, DisplayName: Watch Hand Sec. Size, FieldType: Float, DefaultValue: 90, MinRange: 10, MaxRange: 100, Description: Range between 10 and 100

'#DesignerProperty: Key: IntExample, DisplayName: Int Example, FieldType: Int, DefaultValue: 10, MinRange: 0, MaxRange: 100, Description: Note that MinRange and MaxRange are optional.
'#DesignerProperty: Key: StringWithListExample, DisplayName: String With List, FieldType: String, DefaultValue: Sunday, List: Sunday|Monday|Tuesday|Wednesday|Thursday|Friday|Saturday
'#DesignerProperty: Key: StringExample, DisplayName: String Example, FieldType: String, DefaultValue: Text
#DesignerProperty: Key: ColorBackground, DisplayName: Color Background, FieldType: Color, DefaultValue: #FF404040, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: ColorWatchHand, DisplayName: Color Watch Hand, FieldType: Color, DefaultValue: #FFDC143C, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: ColorMiddle, DisplayName: Color Middle, FieldType: Color, DefaultValue: #FF808080, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: ColorHours, DisplayName: Color Hours, FieldType: Color, DefaultValue: #80FFFFFF, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: ColorHoursText, DisplayName: Color Hours Text, FieldType: Color, DefaultValue: #FF000000, Description: You can use the built-in color picker to find the color values.
#DesignerProperty: Key: ColorOutline, DisplayName: Color Outline, FieldType: Color, DefaultValue: #80000000, Description: You can use the built-in color picker to find the color values.
'#DesignerProperty: Key: DefaultColorExample, DisplayName: Default Color Example, FieldType: Color, DefaultValue: Null, Description: Setting the default value to Null means that a nullable field will be displayed.
Sub Class_Globals
	Private mEventName As String 'ignore
	Private mCallBack As Object 'ignore
	Private mBase As Panel
	Private Const DefaultColorConstant As Int = -984833 'ignore
	Dim Canvas1 As Canvas
	Dim Timer1 As Timer
	
	Public ColorBackground As Int = Colors.DarkGray
	Public ColorWatchHand As Int = Colors.Red
	Public ColorMiddle As Int = Colors.LightGray
	Public ColorHours As Int = Colors.White
	Public ColorHoursText As Int = Colors.Black
	Public ColorOutline As Int = Colors.Black
	Public TextOnOff As Boolean = True
	Public TextBGOnOff As Boolean = True
	Public MiddleOnOff As Boolean = True
	Public MinutesOnOff As Boolean = True
	Public SecondOnOff As Boolean = True
	Public TextOffset As Float
	Public FontSize As Float
	Public WatchHandSize As Float
	Public WatchHandMinSize As Float
	Public WatchHandSecSize As Float
	
	Private BGBitmap As BitmapDrawable
	
End Sub

Public Sub Initialize (Callback As Object, EventName As String)

	mEventName = EventName
	mCallBack = Callback

End Sub

Public Sub DesignerCreateView (Base As Panel, Lbl As Label, Props As Map)

	mBase = Base

	TextOnOff = Props.Get("TextOnOff")
	TextBGOnOff = Props.Get("TextBGOnOff")
	MiddleOnOff= Props.Get("MiddleOnOff")
	MinutesOnOff= Props.Get("MinutesOnOff")
	SecondOnOff= Props.Get("SecondOnOff")
	
	TextOffset = Props.Get("TextOffset")
	FontSize = Props.Get("FontSize")
	WatchHandSize= Props.Get("WatchHandSize")
	WatchHandMinSize= Props.Get("WatchHandMinSize")
	WatchHandSecSize= Props.Get("WatchHandSecSize")
	
	ColorBackground = Props.Get("ColorBackground")
	ColorWatchHand = Props.Get("ColorWatchHand")
	ColorMiddle = Props.Get("ColorMiddle")
	ColorHours = Props.Get("ColorHours")
	ColorHoursText = Props.Get("ColorHoursText")
	ColorOutline = Props.Get("ColorOutline")
	    
	Canvas1.Initialize(mBase)
	Canvas1.AntiAlias = True
	
	'BGBitmap.Initialize(LoadBitmap(File.DirAssets,"bg1.png"))
	'BGBitmap.Initialize(LoadBitmap(File.DirAssets,"bg2.png"))
	'BGBitmap.Initialize(LoadBitmap(File.DirAssets,"bg3.png"))
	'BGBitmap.Initialize(LoadBitmap(File.DirAssets,"bg4.png"))
	'BGBitmap.Initialize(LoadBitmap(File.DirAssets,"24h_clock.png"))
	
	Timer1.Initialize("Timer1",500)
	Timer1.Enabled=True
		
	Draw(DateTime.Now)
	'Draw(0)
	
End Sub

Public Sub GetBase As Panel
	Return mBase
End Sub

private Sub Timer1_Tick
	Draw(DateTime.Now)
End Sub

'Timer On / Off
public Sub Timer_OnOff(OnOff As Boolean)
	Timer1.Enabled = OnOff
End Sub

'.SetBackgroundBitmap(LoadBitmap(File.DirAssets,"bg1.png"))
public Sub SetBackgroundBitmap(BackgroundBitmap As Bitmap)
	
	If BackgroundBitmap.IsInitialized Then
		BGBitmap.Initialize(BackgroundBitmap)
	Else
		BGBitmap = Null
	End If
	
End Sub

private Sub Draw(Begin As Long)
				
	Canvas1.DrawColor(Colors.Transparent)
			
	Dim Width As Float = Canvas1.Bitmap.Width
	Dim Height As Float = Canvas1.Bitmap.Height

	Dim cx As Float = Width / 2.0
	Dim cy As Float = Height / 2.0

	'Canvas1.DrawLine(0,0,Width,Height,Colors.Gray,1)
	'Canvas1.DrawLine(0,Height,Width,0,Colors.Gray,1)
	
	Dim angle As Float
	Dim x As Float ,	y As Float
	Dim x1 As Float,	y1 As Float
	Dim x2 As Float,	y2 As Float

	Dim border As Float = Min( cx,cy)

		
	Dim size1 As Float = border / 100.0
	Dim size2 As Float = size1 *4
	Dim size3 As Float = size1 *6
	Dim size4 As Float = size1 *8
	Dim size5 As Float = size1 *20

	Dim FontOffsetHere As Float
	FontOffsetHere = border * (TextOffset / 100.0)

	Dim FontSizeHere As Float
	FontSizeHere = FontOffsetHere * (FontSize / 100.0)

	

	Dim rect As Rect
	rect.Initialize(0,0,Width,Height)

	If BGBitmap.IsInitialized Then
		Canvas1.DrawDrawable(BGBitmap,rect)
	Else
		Canvas1.DrawCircle(cx,cy,FontOffsetHere,ColorOutline,False,size1) 'Ziffern Blatt
		Canvas1.DrawCircle(cx,cy,FontOffsetHere,ColorBackground,True,1) 'Ziffern Blatt
	End If
	
	For angle = 1 To 24 
		x = cx - SinD(angle*15.0) * FontOffsetHere
		y = cy + CosD(angle*15.0) * FontOffsetHere
		
		If TextBGOnOff = True Then
			Canvas1.DrawCircle(x,y,size3,ColorOutline ,False,size1) 'Stunden Hintergrund
			Canvas1.DrawCircle(x,y,size3,ColorHours ,True,1) 'Stunden Hintergrund
		End If
		
		If TextOnOff=True Then
			Canvas1.DrawText(angle,x,y+FontSizeHere/2.0,Typeface.DEFAULT_BOLD,FontSizeHere,ColorHoursText,"CENTER") 'Stunden Text
		End If
		
	Next
	
	#region Zeiger
	
	Dim hour As Float
	hour = DateTime.GetHour(Begin)
	
	Dim minutes As Float
	minutes = DateTime.GetMinute(Begin)

	Dim seconds As Float
	seconds = DateTime.GetSecond(Begin)

	'--------------------------------------------- Seconds

	If SecondOnOff = True Then

		Dim WatchHandSizeHere As Float
		WatchHandSizeHere = border * (WatchHandSecSize / 100.0)

		angle = seconds * 6.0

		x = cx +SinD(angle) *( WatchHandSizeHere )
		y = cy -CosD(angle) *( WatchHandSizeHere )

		x1 = cx +SinD(angle-90.0) * size2
		y1 = cy -CosD(angle-90.0) * size2

		x2 = cx +SinD(angle+90.0) * size2
		y2 = cy -CosD(angle+90.0) * size2

		Dim Path1 As Path
		Path1.Initialize(cx, cy)
		Path1.LineTo(x1,y1)
		Path1.LineTo(x,y)
		Path1.LineTo(x2,y2)
		
		'Canvas1.DrawCircle(cx,cy,size3,ColorOutline,False,size1) 'Mittel Punkt Zeiger
		Canvas1.DrawPath(Path1, ColorOutline, False, size1) 'Zeiger Rand
		'Canvas1.DrawCircle(cx,cy,size3,ColorWatchHand,True,1) 'Mittel Punkt Zeiger
		Canvas1.DrawPath(Path1, ColorWatchHand, True, 1) 'Zeiger

	End If

	'--------------------------------------------- Minutes

	If MinutesOnOff = True Then

		Dim WatchHandSizeHere As Float
		WatchHandSizeHere = border * (WatchHandMinSize / 100.0)

		angle = minutes * 6.0

		x = cx +SinD(angle) *( WatchHandSizeHere )
		y = cy -CosD(angle) *( WatchHandSizeHere )

		x1 = cx +SinD(angle-90.0) * size2
		y1 = cy -CosD(angle-90.0) * size2

		x2 = cx +SinD(angle+90.0) * size2
		y2 = cy -CosD(angle+90.0) * size2

		Dim Path1 As Path
		Path1.Initialize(cx, cy)
		Path1.LineTo(x1,y1)
		Path1.LineTo(x,y)
		Path1.LineTo(x2,y2)
		
		'Canvas1.DrawCircle(cx,cy,size3,ColorOutline,False,size1) 'Mittel Punkt Zeiger
		Canvas1.DrawPath(Path1, ColorOutline, False, size1) 'Zeiger Rand
		'Canvas1.DrawCircle(cx,cy,size3,ColorWatchHand,True,1) 'Mittel Punkt Zeiger
		Canvas1.DrawPath(Path1, ColorWatchHand, True, 1) 'Zeiger

	End If

	'--------------------------------------------- Hours

	WatchHandSizeHere = border * (WatchHandSize / 100.0)

	angle = ((hour * 60.0 + minutes) / 4.0) 
	
	x = cx -SinD(angle) *( WatchHandSizeHere )
	y = cy +CosD(angle) *( WatchHandSizeHere )

	x1 = cx -SinD(angle-90.0) * size3
	y1 = cy +CosD(angle-90.0) * size3

	x2 = cx -SinD(angle+90.0) * size3
	y2 = cy +CosD(angle+90.0) * size3

	Dim Path1 As Path
	Path1.Initialize(cx, cy)
	Path1.LineTo(x1,y1)
	Path1.LineTo(x,y)
	Path1.LineTo(x2,y2)
	
	Canvas1.DrawCircle(cx,cy,size3,ColorOutline,False,size1) 'Mittel Punkt Zeiger
	Canvas1.DrawPath(Path1, ColorOutline, False, size1) 'Zeiger Rand
	Canvas1.DrawCircle(cx,cy,size3,ColorWatchHand,True,1) 'Mittel Punkt Zeiger
	Canvas1.DrawPath(Path1, ColorWatchHand, True, 1) 'Zeiger

	'---------------------------------------------
	
	#end region
	
	If MiddleOnOff=True Then
		Canvas1.DrawCircle(cx,cy,size2,ColorOutline,False,size1) 'Mittel Punkt
		Canvas1.DrawCircle(cx,cy,size2,ColorMiddle,True,1) 'Mittel Punkt
	End If
	
	mBase.Invalidate
		
End Sub
